/* The cheapest, quickest to write program I can make up to strip line numbers.
// The line number field is variable width and has optional leading whitespace.
// Written by Joel Rees, Takino, Hyogo, Japan, January 2000.
// Too Q&D to bother copyrighting, assigned to the public domain.
// Since it is in the public domain, it can't be copyrighted. 
// Your personal expression of it may be copyrightable, however.
//
// The changes in my programing style prove that I am turning Japanese.
// Current e-mail: joel_rees@sannet.ne.jp, reiisi@nettaxi.com
*/


#define ON_Macintosh


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>


#if defined ON_Macintosh
#	pragma		push
#	pragma		only_std_keywords off
#	include		<Types.h>
#	include		<Fonts.h>
#	pragma		pop
#endif


#if defined ON_Macintosh
#	include		<sioux.h>
#	include		<console.h>
#endif


int main( int argc, char * argv[] )
{
	int ch;
/* */
#	if defined ON_Macintosh
	{	Str31 name = "\pOsaka|";
		short familyID = 0;
	/* */
		GetFNum( name, &familyID );
		SIOUXSettings.fontsize = 12;
		SIOUXSettings.fontid = familyID;
		SIOUXSettings.showstatusline = 1;
		argc = ccommand( &argv );
	}
#	endif
/* */
	while ( !feof( stdin ) )
	{	
		while ( ( ch = getchar() ) != EOF && isspace( ch ) )
		{	/* bit bucket */ }
		if ( ch != EOF )
		{	ungetc( ch, stdin );
		}
		while ( ( ch = getchar() ) != EOF && isdigit( ch ) )
		{	/* bit bucket */ }
		if ( ch != EOF )
		{	ungetc( ch, stdin );
		}
		while ( ( ch = getchar() ) != EOF 
				&& ch != '\n' && ch != '\r' /* && ch != '\0' */ )
		{	putchar( ch );	/* Copy, but eoln type characters go to bit bucket. */
		}
		putchar( '\n' );	/* At one time, this was supposed to output full CR/LF on DOS. */
		/* Rather than try to figure out the intricacies of the end-of-file and end-of-line 
		// interaction, I am just letting an extra empty line be dumped to the output. 
		// The present application is not sensitive to such things.
		*/
	}
	return EXIT_SUCCESS;
}

